darcs

Issue 2274 darcs convert appears to inefficiently frequently create the patch index.

Title darcs convert appears to inefficiently frequently create the patch index.
Priority bug Status resolved
Milestone Resolved in 2.10.0 HEAD
Superseder Nosy List Serware, markstos
Assigned To
Topics Darcs2, PatchIndex, Performance

Created on 2012-12-10.19:58:55 by markstos, last changed 2013-04-25.21:42:51 by noreply.

Messages
msg16388 (view) Author: markstos Date: 2012-12-10.19:58:51
1. Summarise the issue (what were doing, what went wrong?)

darcs convert --debug-verbose on a "hashed" repo with 18,000 patches in 
it. 

Every few seconds, the work pauses while darcs reports "About to create 
patch index".

2. What behaviour were you expecting instead?

I expect darcs to create the patch index once at the end, which is 
presumably notably faster on large repo.

3. What darcs version are you using? (Try: darcs --exact-version)

Darcs 2.9.6

4. What operating system are you running?
  
Ubuntu Linux 12.04 on EC2.
msg16605 (view) Author: gh Date: 2013-02-15.16:51:57
Mark, can you try again with patch1027 (which is now in screened)?
msg16606 (view) Author: markstos Date: 2013-02-15.18:08:02
I pulled the patch, and re-compiled. "darcs --version" now reports 2.9.7 
+ 48 patches.

I re-tried with darcs convert --debug-verbose, and I still see this 
regularly in the output:

 About to create patch index...
 Patch index created

Are you getting a different result for the same command? I imagine you 
could just well substitute the darcs repo instead of the one I have.
msg16612 (view) Author: kowey Date: 2013-02-16.08:16:38
Can anybody reproduce this? Looks potentially tricky to do so, need to 
create some repository that will trigger more than one patch index build 
but not too many

Mark: don't we have options to disable the patch index? (as a 
workaround)

I'm afraid this one will likely drift to the bottom of priority pile as 
things go :-(
msg16667 (view) Author: markstos Date: 2013-02-17.00:51:47
Let's just "give up" for now. "darcs convert" eventually produces the 
correct result, and the only cases that these benefits are the 
increasingly small number of darcs 1.x users, and it's only a one-time 
slowness. Given the project resource constraints, I agree this shouldn't 
be a priority.
msg16779 (view) Author: noreply Date: 2013-04-25.21:42:49
The following patch sent by Guillaume Hoffmann <guillaumh@gmail.com> updated issue issue2274 with
status=resolved;resolvedin=2.10.0 HEAD

* Resolve issue2274: create patch index only with commands that take a lock 
Ignore-this: dd65303a8ec0e308118f0e3dca9df14b
History
Date User Action Args
2012-12-10 19:58:55markstoscreate
2013-02-15 16:51:58ghsetmessages: + msg16605
2013-02-15 18:08:03markstossetmessages: + msg16606
2013-02-16 08:16:40koweysetpriority: bug
status: unknown -> needs-reproduction
messages: + msg16612
2013-02-17 00:51:49markstossetstatus: needs-reproduction -> given-up
messages: + msg16667
2013-04-25 21:42:51noreplysetstatus: given-up -> resolved
messages: + msg16779
resolvedin: 2.10.0 HEAD